﻿using System;
using System.Collections.Generic;

namespace GenericLibrary
{
    class Program
    {
        public static void Main(string[] args)
        {
            EvilProgrammerWorkingWithList();
        }

        private static void EvilProgrammerWorkingWithList()
        {
            CatalogList<int, Student> students = new CatalogList<int, Student>();
            Student st1 = new Student(1, "Anders");
            Student st2 = new Student(23, "John");
            students.Add(st1);
            students.Add(st2);
            ICollection<Student> coll = students.GetAll();

            coll.Add(st1); // The Evil Programmer in action
            // Now students has two duplicate elements
            Console.WriteLine(students);
        }
    }

    class Student : IIdentifiable<int>
    {
        public int Id { get; private set; }
        public String Name { get; set; }

        public Student(int id, string name)
        {
            Id = id;
            Name = name;
        }

        public override string ToString()
        {
            return Id + ": " + Name;
        }
    }
}
